#include "SoURLTexture2.h"

SoURLTexture2::SoURLTexture2(char *url)
{
  //Reads PGM file possibly with one line of comment

  Timer *dt = new Timer;
  
  WebNode *node = new WebNode(url);
  dt->stop("Texture loaded");
  
  buf = (unsigned char *)node->getBuffer();

  int dimx = 0, dimy = 0;

  while(buf[0]!='\n') buf++; 	//the header (P?)
  buf++;

  if(buf[0]=='#') {		//the comment
    while(buf[0]!='\n') buf++;
    buf++;
  }

  while(buf[0]!=' ') {
    dimx = 10*dimx + buf[0] - '0'; 
    buf++;
  }
  buf++;

  while(buf[0]!='\n') {
    dimy = 10*dimy + buf[0] - '0'; 
    buf++;
  }
  buf++;

  while(buf[0]!='\n') buf++; //255\n
  buf++;

  unsigned char *revData;
  
  NewVector(revData, dimx*dimy*3, unsigned char);
  
  for(int i=0; i<dimx; i++)
    for(int j=0; j<3*dimy; j++) 
      revData[i*dimx*3+j] = buf[(dimx-i-1)*dimx*3+j];  
  
  //  printf("URL: %s\nTexture dimension is %d by %d\n", url, dimx, dimy);

  //create the SoTexture2 node
  image.setValue(SbVec2s(dimx, dimy), 3, revData);

  //in order to remove the WHOLE buffer
  delete (unsigned char *)node->getBuffer();
  delete node;
  buf = revData;
  
}

SoURLTexture2::~SoURLTexture2()
{
  delete buf;
  //  cerr << "texture buffer is being deleted\n";
}
